concrete RouteEng of Route = TransportEng ** open ResRoute in {
lincat 
  Route = { s : Str } ;
  [Leg] = { s : LegPos => Str } ;
  Leg = { s : LegPos => Str } ;
  [Stop] = { start : Str; end : Str } ;
lin 
  LegsRoute ls = { s = ls.s ! FirstLeg };
  ConsLeg l r = 
    { s = table {
		FirstLeg => l.s ! FirstLeg ++ "." ++ r.s ! NextLeg ;
		NextLeg  => l.s ! NextLeg ++ "." ++ r.s ! NextLeg
		}
    } ;
  BaseLeg l = { s = \\p => l.s ! p ++ "." } ;
  LineLeg l ss = 
    { s = table {
		FirstLeg => "Take" ++ l.s ++ "from" ++ ss.start ++
		            "to" ++ ss.end ; 
		NextLeg  => ["Change to"] ++ l.s ++ "to" ++ ss.end
		}
    } ;
  NamedLine n = { s = n.s } ;
  ConsStop s ss = { start = s.s; end = ss.end } ;
  BaseStop s1 s2 = { start = s1.s; end = s2.s } ;
}